<?php
class SystemAllMailController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Configure','Validation','Mailaddress','Host','Poll','Validation','Version','Someauth','Authority','Somemod','Module');
	var $layout='system';
	//    var $pageTitle = 'LVシステム管理/全体設定/ライセンス';

	function beforeFilter()
	{
		// $this->Configure->write('debug',0);
		parent::beforeFilter();
	}
	
	function index()
	{
		$this->pageTitle = __('title',$return = true);   
		$search= $this->requestAction('/system_all_mail/mail_set/',array('return'));
		$this->set('search',$search);
		//$this->render('index');
	}
	
	function mail_set(){
		$this->layout='ajax';
		$group_id=$this->_getUserGroup();
		$mailaddress = null;
		$mail_notice= $this->data['Grpalt']['mail_notice'];

		{
			//first to this page
			//	smtp_server,smtp_port,mail_address,pop_check,pop,pop_port,pop_user,pop_password,mail_notice,mails_address
			$result_alt=$this->Mailaddress->findAll();
			//			//			echo '+++++++++'.count($result_alt);

			if(!empty($result_alt)){
				foreach ($result_alt as $key=>$value){
					if($key==count($result_alt)-1){
						$mails_address=$mails_address.$value['Mailaddress']['mails_address'];
					}else{
						$mails_address=$mails_address.$value['Mailaddress']['mails_address'].";";
					}
					$smtp_server = $value['Mailaddress']['smtp_server'];
					$smtp_port = $value['Mailaddress']['smtp_port'];
					$mail_address = $value['Mailaddress']['mail_address'];
					
					$smtp_check = $value['Mailaddress']['smtp_check'];
					$smtp_user = $value['Mailaddress']['smtp_user'];
					$smtp_password = $value['Mailaddress']['smtp_password'];
					$rsmtp_password = $value['Mailaddress']['smtp_password'];
					
					$pop_check = $value['Mailaddress']['pop_check'];
					$pop = $value['Mailaddress']['pop'];
					$pop_port = $value['Mailaddress']['pop_port'];
					$pop_user = $value['Mailaddress']['pop_user'];
					$pop_password = $value['Mailaddress']['pop_password'];
					$rpop_password = $value['Mailaddress']['pop_password'];
					
					$smtp_ssl = $value['Mailaddress']['smtp_ssl'];
				}
				$mail_notice= $result_alt[0]['Mailaddress']['mail_notice'];
				if(empty($mail_notice))	{
					$mail_notice=3;
				}
			}else{
				$mailadress=null;
				$mail_notice=3;
			}

			$this->data['Mail']['mails_address'] =$mails_address;
			$this->data['Mail']['smtp_server'] =$smtp_server;
			$this->data['Mail']['smtp_port'] =$smtp_port;
			$this->data['Mail']['mail_address'] = $mail_address;
			
			$this->data['Mail']['smtp_check'] = $smtp_check;
			$this->data['Mail']['smtp_user'] = $smtp_user;
			//$this->data['Mail']['smtp_password'] = $smtp_password;
			//$this->data['Mail']['rsmtp_password'] = $rsmtp_password;
								
			$this->data['Mail']['pop_check'] = $pop_check;
			$this->data['Mail']['pop'] = $pop;

			$this->data['Mail']['pop_user'] = $pop_user;
			//$this->data['Mail']['pop_password'] = $pop_password;
			//$this->data['Mail']['rpop_password'] = $rpop_password;

			$this->data['Mail']['smtp_ssl'] = $smtp_ssl;
			
			$this->set('result_alt',$result_alt);
			if($smtp_port && !empty($smtp_port)){
				$this->data['Mail']['smtp_port'] =$smtp_port;
			}else{
				$this->data['Mail']['smtp_port'] =25;
			}
			if($pop_port && !empty($pop_port)){
				$this->data['Mail']['pop_port'] = $pop_port;
			}else{
				$this->data['Mail']['pop_port'] = 110;
			}
		}//var_dump($this->data);
		//echo '==============='.$mail_notice;
		//mail search
		if($this->data['Mail']['pop_check'] == 1){
			$this->set('set','1');
		}
		if($this->data['Mail']['smtp_check'] == 1){
			$this->set('smtp_set','1');
		}
		$this->set('mails_address',$mails_address);
		$this->set('smtp_server',$smtp_server);
		$this->data['Grpalt']['mail_notice']=$mail_notice;
		//$this->render('mail_set');
	}
	
	
	function set_str_encoding($name)
    {
        $result= mb_convert_encoding($name,__('CharacterSet',$retrun=true),"UTF-8"); 
        return $result;
    } 
	
	function mail_test(){
		$this->autoRender = false; // Viewを使わないように
		
		$title = $_GET['title'];//echo $title;
		
		
		$result_alt=$this->Mailaddress->findAll();
		if(!empty($result_alt))
		{
			foreach ($result_alt as $key => $value)
			{
				if($key==count($result_alt)-1){
					$mails_address=$mails_address.$value['Mailaddress']['mails_address'];
				}else{
					$mails_address=$mails_address.$value['Mailaddress']['mails_address'].";";
				}
				$smtp_server = $value['Mailaddress']['smtp_server'];
				$smtp_port = $value['Mailaddress']['smtp_port'];
				$mail_address = $value['Mailaddress']['mail_address'];
				
				$smtp_check = $value['Mailaddress']['smtp_check'];
				$smtp_user = $value['Mailaddress']['smtp_user'];
				$smtp_password = $this->Lv->save_decode($value['Mailaddress']['smtp_password']);
				//$rsmtp_password = $value['Mailaddress']['smtp_password'];
	
				$pop_check = $value['Mailaddress']['pop_check'];
				$pop = $value['Mailaddress']['pop'];
				$pop_port = $value['Mailaddress']['pop_port'];
				$pop_user = $value['Mailaddress']['pop_user'];
				$pop_password = $this->Lv->save_decode($value['Mailaddress']['pop_password']);
				//$rpop_password = $value['Mailaddress']['pop_password'];
				$smtp_ssl = $value['Mailaddress']['smtp_ssl'];
			}
			
			//設定ファイル内容
			$contents = "";
			$contents .= "[Config]\r\n";
			$contents .= "Address=".$mails_address;
			$contents .= "\r\n";
			$contents .= "FromAddress=".$mail_address;
			$contents .= "\r\n";
			$contents .= "SMTPServer=".$smtp_server;
			$contents .= "\r\n";
			$contents .= "SMTPUser=".$smtp_user;
			$contents .= "\r\n";
			$contents .= "SMTPPassword=".$smtp_password;
			$contents .= "\r\n";
			$contents .= "SMTPAuth=".$smtp_check;
			$contents .= "\r\n";
			$contents .= "SMTPPort=".$smtp_port;
			$contents .= "\r\n";
			$contents .= "SMTPSSL=".$smtp_ssl;
			$contents .= "\r\n";
			$contents .= "POPServer=".$pop;
			$contents .= "\r\n";
			$contents .= "POPUser=".$pop_user;
			$contents .= "\r\n";
			$contents .= "POPPassword=".$pop_password;
			$contents .= "\r\n";
			$contents .= "POPBeforeSMTPFlag=".$pop_check;
			$contents .= "\r\n";
			$contents .= "POPPort=".$pop_port;
			$contents .= "\r\n";
			if(!empty($title)){
				$contents .= "Title=".$title;
				$contents .= "\r\n";
			}
	
			//一時ファイル作成　BEGIN
			$filename = "mail".substr(md5(time().rand(0,1000000)),0,10) . ".ini";
			$csv_folder=ROOT.DS.APP_DIR.DS."tmp".DS."csv".DS;
			$file = $csv_folder.$filename;
			$fp = fopen($file, 'w');  

			$enc= $this->set_str_encoding($contents);
			fputs($fp, $enc);
			
			fclose($fp);
	
			//exe実行
			$v_path=(VENDORS);
			$tmpfname = "MailTest.exe";//sprintf("%sMailTest.exe", $v_path);
	$wd = getcwd();
	chdir($v_path);
		/*
			$tmpfname = tempnam("/tmp", "MAI");
			rename($tmpfname, $tmpfname . ".exe");
			$tmpfname = $tmpfname . ".exe";
			copy(sprintf("%sMailTest.exe", $v_path), $tmpfname);
			*/
			$result = exec( sprintf("%s \"%s\"", $tmpfname, $file), $output, $return_var);
			//unlink($tmpfname);
			//echo $tmpfname;echo $file;
			//一時ファイル削除
			unlink($file);
			chdir($wd);
			echo $return_var;
			return;
			
		}
		echo 4;
		return;
	}
	
	//設定更新
	function mail_save(){
		$this->layout='ajax';
		$group_id=$this->_getUserGroup();
		$err=null;
		$mailaddress = null;
		$mail_notice= $this->data['Grpalt']['mail_notice'];
//var_dump($this->data);
		$errosmail = array();
			//set button onclick
			$mails_address=trim($this->data['Mail']['mails_address']);
			$smtp_server=trim($this->data['Mail']['smtp_server']);
			$smtp_port=trim($this->data['Mail']['smtp_port']);
			$mail_address=trim($this->data['Mail']['mail_address']);
			
			$smtp_ssl = $this->data['Mail']['smtp_ssl'];
			
			$smtp_check=trim($this->data['Mail']['smtp_check']);
			$smtp_user = trim($this->data['Mail']['smtp_user']);
			$smtp_password = trim($this->data['Mail']['smtp_password']);
			$rsmtp_password = trim($this->data['Mail']['rsmtp_password']);
			
			$pop_check=trim($this->data['Mail']['pop_check']);
			$pop = trim($this->data['Mail']['pop']);
			$pop_port = trim($this->data['Mail']['pop_port']);
			if(!$pop_port && empty($pop_port)){
				$this->data['Mail']['pop_port'] = 110;
			}
			$pop_user = trim($this->data['Mail']['pop_user']);
			$pop_password = trim($this->data['Mail']['pop_password']);
			$rpop_password = trim($this->data['Mail']['rpop_password']);

			//						echo $mail_notice.'<br>'.$mail_address.'<br>'.$smtp_server.'<br>'.$smtp_port.'<br>'.$mails_address.'<br>'.$pop_check.'<br>'.$pop.'<br>'.$pop_port.'<br>'.$pop_user.'<br>'.$pop_password.'<br>'.$rpop_password.'<br>';
			$email = null;
			$emailsave = null;
			if(empty($mails_address)){
				$temp = 2;
				if ($temp==2) {
					$err[]=__('mailnull',$return = true);
					//					$this->set('err',$err);
				}
			}
			$newmailaddresses = array();
			$mails_address=split('[;]',trim($mails_address));
			for($i=0;$i<count($mails_address);$i++){
				if($i == 0){
					$newmailaddresses[] = $mails_address[$i];
				}else if(!in_array($mails_address[$i],$newmailaddresses)&&$mails_address[$i] != ""){
					$newmailaddresses[] = $mails_address[$i];
				}
			}
			for ($j=0;$j<count($newmailaddresses);$j++){
				$set_mail_address = trim($newmailaddresses[$j]);
				if(ereg("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$",$set_mail_address)){
					$emailsave = 1;
				}
				else {
					$emailsave = 2;

				}
				if(!$this->Validation->maxLength(trim($newmailaddresses[$j]),2000))
				{
					$err[]=__('sendfax',$return = true)."　".__('E-00300',$return = true);
				}

			}
			if($emailsave==2&&(count($mails_address)>=1)&&$temp!=2) {
				$errosmail[]=__('emailerror',$return = true);
			}

			if(!$this->Check->checkAllHalf($smtp_server))
			{
				$err[]=__('SMTP server',$return = true)."　".__('E-00400',$return = true);
			}
			if(!$this->Validation->maxLength($smtp_server,200))
			{
				$err[]=__('SMTP server',$return = true)."　".__('E-00300',$return = true);
			}
			if($this->Validation->blank($smtp_server))
			{
				$err[]=__('SMTP server',$return = true)."　".__('E-00100',$return = true);
			}

			if($this->Validation->blank($smtp_port))
			{
				$err[]=__('port',$return = true)."　".__('E-00100',$return = true);
			}
			else{
				if(!$this->Validation->numeric($smtp_port))
				{
					$err[]=__('port',$return = true)."　".__('E-00600',$return = true);
				}
			}

			if(!$this->Validation->email($mail_address)&& !$this->Validation->blank($mail_address))
			{
				$err[]=__('mail address',$return = true)."　".__('E-02200',$return = true);
			}
			if(!$this->Validation->maxLength($mail_address,200))
			{
				$err[]=__('mail address',$return = true)."　".__('E-00300',$return = true);
			}
			if($this->Validation->blank($mail_address))
			{
				$err[]=__('mail address',$return = true)."　".__('E-00100',$return = true);
			}
			if($smtp_check=='1')
			{
				if($this->Validation->blank($smtp_user))
				{
					$err[]=__('SMTP user',$return = true)."　".__('E-00100',$return = true);
				}else{
					if(!$this->Check->checkAllHalf($smtp_user))
					{
						$err[]=__('SMTP user',$return = true)."　".__('E-00400',$return = true);
					}
					if(!$this->Validation->maxLength($smtp_user,200))
					{
						$err[]=__('SMTP user',$return = true)."　".__('E-00300',$return = true);
					}
				}
				if($this->Validation->blank($smtp_password))
				{
					//$err[]=__('SMTP password',$return = true)."　".__('E-00100',$return = true);
				}else{
					if(!$this->Validation->maxLength($smtp_password,200))
					{
						$err[]=__('SMTP password',$return = true)."　".__('E-00300',$return = true);
					}
				}
				if($this->Validation->blank($rsmtp_password))
				{
					//$err[]=__('SMTP password confirmation',$return = true)."　".__('E-00100',$return = true);
				}else{
					if(!$this->Validation->maxLength($rsmtp_password,200))
					{
						$err[]=__('SMTP password confirmation',$return = true)."　".__('E-00300',$return = true);
					}
					if($smtp_password!=$rsmtp_password)
					{
						$err[]=__('E-01400',$return = true);
					}
				}
			}
			if($pop_check=='1')
			{
				if($this->Validation->blank($pop))
				{
					$err[]=__('POP server',$return = true)."　".__('E-00100',$return = true);
				}else{
					if(!$this->Check->checkAllHalf($pop))
					{
						$err[]=__('POP server',$return = true)."　".__('E-00400',$return = true);
					}
					if(!$this->Validation->maxLength($pop,200))
					{
						$err[]=__('POP server',$return = true)."　".__('E-00300',$return = true);
					}
				}
				if($this->Validation->blank($pop_port))
				{
					$err[]=__('POP port',$return = true)."　".__('E-00100',$return = true);
				}else{
					if(!$this->Validation->numeric($pop_port))
					{
						$err[]=__('POP port',$return = true)."　".__('E-00600',$return = true);
					}
				}
				if($this->Validation->blank($pop_user))
				{
					$err[]=__('POP user',$return = true)."　".__('E-00100',$return = true);
				}else{
					if(!$this->Check->checkAllHalf($pop_user))
					{
						$err[]=__('POP user',$return = true)."　".__('E-00400',$return = true);
					}
					if(!$this->Validation->maxLength($pop_user,200))
					{
						$err[]=__('POP user',$return = true)."　".__('E-00300',$return = true);
					}
				}
				if($this->Validation->blank($pop_password))
				{
					//$err[]=__('POP password',$return = true)."　".__('E-00100',$return = true);
				}else{
					if(!$this->Validation->maxLength($pop_password,200))
					{
						$err[]=__('POP password',$return = true)."　".__('E-00300',$return = true);
					}
				}
				if($this->Validation->blank($rpop_password))
				{
					//$err[]=__('POP password confirmation',$return = true)."　".__('E-00100',$return = true);
				}else{
					if(!$this->Validation->maxLength($rpop_password,200))
					{
						$err[]=__('POP password confirmation',$return = true)."　".__('E-00300',$return = true);
					}
					if($pop_password!=$rpop_password)
					{
						$err[]=__('E-01400',$return = true);
					}
				}
			}
			if(!empty($err))
			{
				$this->set('err',$err);
				//				    		debug($err);
			}else{
				if ($emailsave==1) {
					$smtp_encoded = false;
					$pop_encoded = false;
					if($smtp_password == "" || $pop_password == ""){
						$result_alt=$this->Mailaddress->findAll();
		
						if(!empty($result_alt)){
							if($smtp_password == ""){
								$smtp_password = $result_alt[0]['Mailaddress']['smtp_password'];
								$smtp_encoded = true;
							}
							if($pop_password == ""){
								$pop_password = $result_alt[0]['Mailaddress']['pop_password'];
								$pop_encoded = true;
							}
						}
					}
					
					if(!$smtp_encoded)
						$smtp_password=$this->save_encode($smtp_password);
					if(!$pop_encoded)
						$pop_password=$this->save_encode($pop_password);
					
				
					$delete_mail = "delete from mailaddresses";
					$this->Mailaddress->query($delete_mail);

					
					for ($j=0;$j<count($newmailaddresses);$j++){
						$set_mail_address = trim($newmailaddresses[$j]);

						$adddata=Array(
							'Mailaddress' => Array(
								'smtp_server'=>$smtp_server,
								'smtp_port'=>$smtp_port,
								'mails_address'=>$set_mail_address,
								'smtp_check'=>$smtp_check,
								'smtp_user'=>$smtp_user,
								'smtp_password'=>$smtp_password,
								'smtp_ssl'=> $smtp_ssl,
								'pop_check'=>$pop_check,
								'pop'=>$pop,
								'pop_port'=>$pop_port,
								'pop_user'=>$pop_user,
								'pop_password'=>$pop_password,
								'mail_notice'=>$mail_notice,
								'mail_address'=>$mail_address
							)
						);
						
						//addrの追加
						$this->Mailaddress->save($adddata);

						
						if($j==count($newmailaddresses)-1){
							$email = $email.$set_mail_address;
						}else{
							$email = $email.$set_mail_address.';';
						}
					}
					$errosmail[]=__('emailsave',$return = true);
				}

				$this->data['Mail']['mails_address'] = $email;
			}
		
		$this->set('errosmail',$errosmail);

	}
		//パスワード用
	function save_encode($str)
	{
		$str1 = substr($str, 0, 1) ;
		$str2 = substr($str, 1, 1) ;
		$str3 = substr($str, 2, strlen($str)) ;
		$str4=$str2.$str1.$str3;
		$str=base64_encode($str4);
		return $str;
	}
}
?>